﻿using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Styles;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace Prototype.UserControls
{
    class BindableGridDataComboBoxVisibleColumn : GridDataVisibleColumn
    {

        #region dependency properties
        //ItemsSource

        public object ItemsSource
        {
            get { return (object)GetValue(ItemsSourceProperty); }
            set { SetValue(ItemsSourceProperty, value); }
        }

        public static readonly DependencyProperty ItemsSourceProperty =
            DependencyProperty.Register("ItemsSource", typeof(object), typeof(BindableGridDataComboBoxVisibleColumn), new PropertyMetadata(null, ItemsSourcePropertyChanged));

        private static void ItemsSourcePropertyChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            GridDataVisibleColumn gridDataVisibleColumn = (GridDataVisibleColumn)d;
            object itemsSource = (object)e.NewValue;
            if((gridDataVisibleColumn != null) && (itemsSource != null))
            {
                GridDataColumnStyle gridDataColumnStyle = gridDataVisibleColumn.ColumnStyle;
                if (gridDataColumnStyle != null)
                {
                    gridDataColumnStyle.ItemsSource = itemsSource;
                }


            }
        }
        #endregion
    }
}
