﻿using FrameworkLibrary.System.Windows.ComponentModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.ComponentModel;
using Prototype.Model;
using System.Windows.Controls;
using System.Windows;
using Prototype.ExcelImport.Views;
using Prototype.ExcelImport.ViewModels;
using Prototype.ExcelImport.Importers;
using Prototype.Repros;
using System.Collections.ObjectModel;
//using System.Transactions;
//using Prototype.Helpers;

namespace Prototype.ViewModels
{
    public class SuppliersViewModel : CrudViewModelBase<Supplier>
    {
        #region fields
        private ObservableCollection<SupplierType> _Types;
        #endregion

        #region constructors
        public SuppliersViewModel()
            : base("Lieferanten", "Suppliers")
        {
            this.Types = new ObservableCollection<SupplierType>();
            this.EditVisibility = Visibility.Collapsed;
        }


        #endregion

        #region properties
        public ObservableCollection<SupplierType> Types
        {
            get { return _Types; }
            set { _Types = value; }
        }
        #endregion

        #region overridden methods
        public override void OnLoadData()
        {
            this.MyLoadData();


        }
        public override bool OnCheckHasDisplayRights(UserControl userControl)
        {
            return base.OnCheckHasDisplayRights(userControl);
        }
        public override void OnExcelImport(object param)
        {
            if ((!this.Disposed) && (base.GetHasChanges()))
            {
                MessageBoxResult messageBoxResult = MessageBox.Show("Es existieren ungespeicherte Änderungen. Sollen diese vor dem Import gespeichert werden?", "ungespeicherte Änderungen", MessageBoxButton.YesNoCancel);
                if (messageBoxResult == MessageBoxResult.Yes)
                {
                    this.OnSave(null);
                }
            }
            ExcelImportView excelImportView = new ExcelImportView(new StandardExcelImportViewModel(typeof(SupplierExcelImporter)));
            excelImportView.ShowDialog();
            this.OnLoadData();



        }

        public override void OnNew(object param)
        {
            base.OnNew(param);
        }
        public override void OnClone(object param)
        {
            base.OnClone(param);
        }
        public override void OnDelete(object param)
        {
            base.OnDelete(param);
        }
        public override void OnExcelExport(object param)
        {
            base.OnExcelExport(param);
        }

        #endregion

        #region private methods
        private async void MyLoadData()
        {
            if (!this.Disposed)
            {
                this.Data.Clear();

                this.IsBusyText = "Lade Daten...";
                this.IsBusy = true;

                //IEnumerable<Supplier> entities = await this.UnitOfWork.Suppliers.GetAllAsync(false);
                SupplierRepository supplierRepository = (SupplierRepository)this.Repository;
                IEnumerable<Supplier> entities1 = await supplierRepository.GetAllWithTypesAsync(false);
                foreach (Supplier loopentity in entities1)
                {
                    this.Data.Add(loopentity);
                }

                this.Types.Clear();
                //NOTE BK AsNoTracking used to avoid Caching see:
                //http://codethug.com/2016/02/19/Entity-Framework-Cache-Busting/

                IEnumerable<SupplierType> entities2 = await this.UnitOfWork.SupplierTypes.GetAllAsync(false, true);
                foreach (SupplierType loopentity in entities2)
                {
                    this.Types.Add(loopentity);

                }


                this.IsBusy = false;
            }

        }
        #endregion

    }
}
